@echo off
REM Licensed Materials - Property of IBM
REM
REM (C) Copyright IBM Corp. 2014 All Rights Reserved
REM
REM US Government Users Restricted Rights - Use, duplicate or
REM disclosure restricted by GSA ADP Schedule Contract with
REM IBM Corp.
REM IBM_COPYRIGHT_END

    set BAT_FILE=%~n0
    set REG_FILE=%TEMP%\%BAT_FILE%.reg
    set REG_DIR_KEY32=HKEY_LOCAL_MACHINE\SOFTWARE\IBM\IBM Director Server\CurrentVersion
    set REG_DIR_KEY64=HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\IBM\IBM Director Server\CurrentVersion
    set REG_ICC_KEY32=HKEY_LOCAL_MACHINE\SOFTWARE\IBM\ICC\CurrentVersion
    set REG_ICC_KEY64=HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\IBM\ICC\CurrentVersion
    set REG_EXT_KEY32=HKEY_LOCAL_MACHINE\SOFTWARE\IBM\Director\ExtInfo
    set REG_EXT_KEY64=HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\IBM\Director\ExtInfo
    set DIRECTOR_HOME=
    set ICC_HOME=
    set WINSYS=%ComSpec:\cmd.exe=\%
    if exist %WINSYS%find.exe (set FIND=%WINSYS%find.exe) else (set FIND=find)
    if exist "%REG_FILE%" del "%REG_FILE%"
    start /w regedit /e "%REG_FILE%" "%REG_DIR_KEY32%"
    if not exist "%REG_FILE%" start /w regedit /e "%REG_FILE%" "%REG_DIR_KEY64%"
    if not exist "%REG_FILE%" goto dirregerror
    for /F  "usebackq tokens=1-3* delims==" %%i in (`type "%REG_FILE%" ^| %FIND% "Root"`) do (if /%%i==/"Root" set DIRECTOR_HOME=%%j)
    set DIRECTOR_HOME=%DIRECTOR_HOME:"=%
    set DIRECTOR_HOME=%DIRECTOR_HOME:\\=\%
    if "%DIRECTOR_HOME:~-1%"=="\" set DIRECTOR_HOME=%DIRECTOR_HOME:~0,-1%
    del "%REG_FILE%" 
    
call "%DIRECTOR_HOME%\bin\setDirectorHome.bat"

set CURRENT_DIR=%cd%

echo Applying the PSIRT Fix. This may take some time.

smcli installneeded -v -F %CURRENT_DIR%\com.ibm.director.core.kernel.feature_6.3.5.0-20140926-IT04508 > fix.log | type fix.log

find /c "ATKUPD764I Update ""com.ibm.director.core.kernel.feature_6.3.5.0-20140926-IT04508""" %CURRENT_DIR%\fix.log >nul

IF ERRORLEVEL 1 goto fixnotinstalled

IF NOT ERRORLEVEL 1 goto fixinstalled

exit /b 1


:fixnotinstalled

find /c "ATKUPD288I The install needed updates task has completed successfully" %CURRENT_DIR%\fix.log >nul

IF ERRORLEVEL 1 goto showerror

IF NOT ERRORLEVEL 1 goto executeFile

exit /b 1


:fixinstalled
"%DIRECTOR_HOME%jre\bin\java" -cp "%DIRECTOR_HOME%lwi\runtime\USMiMain\eclipse\plugins\com.ibm.director.core.kernel_6.3.5.0-20140926-IT04508\classes\core-kernel.jar";"%DIRECTOR_HOME%lwi\runtime\director\eclipse\plugins\com.ibm.director.security.nl1_6.3.5.jar";"%DIRECTOR_HOME%lwi\runtime\director\eclipse\plugins\com.ibm.director.security.nl1_6.3.0.jar";"%DIRECTOR_HOME%lwi\lib\lwisecurity.jar";"%DIRECTOR_HOME%lwi\lib\passutils.jar" com.ibm.director.security.config.PassDecrypt %*
ECHO Fix for CVE-2014-3099 completed successfully. Please restart the IBM Systems Director Management Server.
exit /b 1

:showerror
ECHO Fix for CVE-2014-3099 failed with Errors. Please fix the issue and retry the operation again. Please check %CURRENT_DIR%\fix.log for more information.
exit /b 1


:executeFile

for /D %%A in ("%DIRECTOR_HOME%lwi\runtime\USMiMain\eclipse\plugins\com.ibm.director.core.kernel_6.3.5.0*") DO set NEW_KERNEL_FOLDER=%%A

"%DIRECTOR_HOME%jre\bin\java" -cp "%NEW_KERNEL_FOLDER%\classes\core-kernel.jar";"%DIRECTOR_HOME%lwi\runtime\USMiMain\eclipse\plugins\com.ibm.director.core.kernel_6.3.5.0-20140926-IT04508\classes\core-kernel.jar";"%DIRECTOR_HOME%lwi\runtime\director\eclipse\plugins\com.ibm.director.security.nl1_6.3.5.jar";"%DIRECTOR_HOME%lwi\runtime\director\eclipse\plugins\com.ibm.director.security.nl1_6.3.0.jar";"%DIRECTOR_HOME%lwi\lib\lwisecurity.jar";"%DIRECTOR_HOME%lwi\lib\passutils.jar" com.ibm.director.security.config.PassDecrypt %*
ECHO Fix for CVE-2014-3099 completed successfully. Please restart the IBM Systems Director Management Server.

exit /b 1





