#!/bin/sh
# Licensed Materials - Property of IBM
#
# (C) Copyright IBM Corp. 2014 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplicate or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.
# IBM_COPYRIGHT_END

#Install the LAFix.

CURRENT_DIR=${PWD}

echo Applying the PSIRT Fix. This may take some time.

TWG_DIRECTORY_ROOT="/opt/ibm/director"
TWG_DIRECTORY_BIN="/opt/ibm/director/lwi/bin"
USMI_PLUGINS_DIR="/opt/ibm/director/lwi/runtime/USMiMain/eclipse/plugins"
DIRECTOR_PLUGINS_DIR="$TWG_DIRECTORY_ROOT/lwi/runtime/director/eclipse/plugins"
MaxVersion="0.0.0.0"
versionArray=`ls $DIRECTOR_PLUGINS_DIR | grep "com.ibm.director.security.nl1_" | grep ".jar"| cut -d'_' -f2 | cut -d'j' -f1|sort`
for versionInArray in $versionArray
    do
          MaxVersion=$versionInArray
    done
SECURITY_NL_PLUGIN="$DIRECTOR_PLUGINS_DIR/com.ibm.director.security.nl1_""$MaxVersion""jar"

smcli installneeded -v -F $CURRENT_DIR/com.ibm.director.core.kernel.feature_6.3.5.0-20140926-IT04508 > fix.log 2>&1

if grep -r "ATKUPD764I Update "\"com.ibm.director.core.kernel.feature_6.3.5.0-20140926-IT04508"\" was installed" $CURRENT_DIR/fix.log &> /dev/null; then

 USMI_KERNEL_PLUGIN="$USMI_PLUGINS_DIR/com.ibm.director.core.kernel_6.3.5.0-20140926-IT04508"
 "$TWG_DIRECTORY_ROOT/jre/bin/java" -cp "$TWG_DIRECTORY_ROOT/lwi/lib/passutils.jar":"$TWG_DIRECTORY_ROOT/lwi/lib/lwisecurity.jar":"$USMI_KERNEL_PLUGIN/classes/core-kernel.jar":"$SECURITY_NL_PLUGIN" com.ibm.director.security.config.PassDecrypt   $*
 echo "Fix for CVE-2014-3099 completed successfully. Please restart the IBM Systems Director Management Server."

else

		if grep -r "ATKUPD288I The install needed updates task has completed successfully" $CURRENT_DIR/fix.log &> /dev/null; then

		KernelMaxVersion="0.0.0.0"
		versionArray=`ls -l $USMI_PLUGINS_DIR | grep "^d"| grep "com.ibm.director.core.kernel_"`
		for versionInArray in $versionArray
   		 do
          		KernelMaxVersion=$versionInArray
    	done
    	
		USMI_KERNEL_PLUGIN="$USMI_PLUGINS_DIR/$KernelMaxVersion"	
		
		"$TWG_DIRECTORY_ROOT/jre/bin/java" -cp "$TWG_DIRECTORY_ROOT/lwi/lib/passutils.jar":"$TWG_DIRECTORY_ROOT/lwi/lib/lwisecurity.jar":"$USMI_KERNEL_PLUGIN/classes/core-kernel.jar":"$SECURITY_NL_PLUGIN" com.ibm.director.security.config.PassDecrypt   $*

		echo "Fix for CVE-2014-3099 completed successfully. Please restart the IBM Systems Director Management Server."

		else
 			 echo Fix for CVE-2014-3099 failed with Errors. Please fix the issue and retry the operation again.Check $CURRENT_DIR/fix.log for more information.
      
		fi
 fi 



